<?php
/*  cms-db  Copyright (C) 2007-2008 Jan Hoffmann
    This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
    This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details.  */
include('checkuser.inc.php');
checkuser('');
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>CMS Inhalt</title>
<link rel="stylesheet" type="text/css" href="style.css">
</head>
<body>

<h1>Variablen</h1>
<p>
	Es k&ouml;nnen folgende Variablen verwendet werden:
	<ul>
		<li>%%TOPMENU%% - erstellt ein Men&uuml; der obersten Ebene (nur Sektionen)</li>
        <li>%%LEFTMENU%% - erstellt ein Men&uuml;, das dem TOPMENU untergeordnet ist</li>
        <li>%%COMPLETEMENU%% - erstellt ein komplettes Men&uuml; f&uuml;r die Website</li>
		<li>%%FOLDINGMENU%% - erstellt ein Men&uuml; f&uuml;r die Website, das je nach aktuell ge&ouml;ffneter Seite die untergeordneten Seiten und Sektionen anzeigt.</li>
        <li>%%PAGESEARCH%% - zeigt ein Feld zum Durchsuchen der Site</li>
        <li>%%PAGETITLE%% - zeigt den Namen der aktuellen Seite an</li>
        <li>%%PAGECONTENT%% - zeigt den Inhalt der aktuellen Seite an</li>
        <li>%%LASTEDIT%% - zeigt die letzte &Auml;nderung der aktuellen Seite an</li>
        <li>%%PAGECOUNT%% - zeigt die Anzahl der Aufrufe der aktuellen Seite an</li>
        <li>%%SITEMAP%% - erstellt eine Sitemap</li>
        <li>%%GUESTBOOK%% - zeigt ein G&auml;stebuch mit Formular an. Der Zeichensatz muss UTF-8 sein.</li>
        <li>%%INCLUDE-{NAME}%% - zeigt den Include <i>{NAME}</i> an (Name ohne Klammern angeben)</li>
        <li>%%REDIRECT-{URL}%% - Weiterleitung auf die angegebene <i>{URL}</i>. <i>{URL}</i> muss absolut sein (z.B. http://domain.tld/forum/, nicht: /forum/). (URL ohne Klammern angeben)</li>
		<li>%%URLBEFORE%%, %%URLAFTER%%, %%URLABSOLUTE%% - die URL-Einstellungen</li>
	</ul>
</p>
<p>
	Alle dieser Variablen k&ouml;nnen im <a href="template.php?<?php echo SID ?>">Template</a> verwendet werden, alle bis auf PAGECONTENT auch in den <a href="pages.php?<?php echo SID ?>">Seiten</a>. In G&auml;stebucheintr&auml;gen werden keine Variablen unterst&uuml;tzt.
</p>

</body>
</html>