<?php
/*  cms-db  Copyright (C) 2007-2008 Jan Hoffmann
    This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
    This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details.  */

function createTopMenu($urlbefore, $urlafter, $sec, $sub, $file) {
	if (!isset($output)) { $output = ''; }
	global $home;
	$output .= '<ul class="topmenu">';
	$ordner = './data/pages';
	$handle = opendir($ordner);
	while (false !== ($file = readdir($handle))) {
		if($file != "." && $file != "..") {
			$pos = strpos($file, ".DEL");
			if ($pos === false) {
				if(is_dir($ordner."/".$file)) {
					$files[] = $file;
				}
			}
		}
	}
	natcasesort($files);
	$replace1 = array('%2F','%2C');
	$replace2 = array('/',',');
	foreach($files as $file) {
		if ($file == '01,Home') {
			$show = $home;
		} else {
			$show = substr($file, 3);
			$show = str_replace("_"," ",$show);
			$show = str_replace("SLASH","/",$show);
			$show = str_replace("AND" ,"&", $show);
		}
		if($sec != $file) {
			$output .= '<li><a href="'.$urlbefore.str_replace($replace1, $replace2, urlencode(substr($ordner,12))).'/'.str_replace($replace1, $replace2, urlencode($file)).'/01,Home'.$urlafter.'" class="topinactive">'.htmlentities($show,ENT_QUOTES).'</a></li>';
		} else {
			$output .= '<li><a href="'.$urlbefore.str_replace($replace1, $replace2, urlencode(substr($ordner,12))).'/'.str_replace($replace1, $replace2, urlencode($file)).'/01,Home'.$urlafter.'" class="topactive">'.htmlentities($show,ENT_QUOTES).'</a></li>';
		}
	}
	closedir($handle);
	$output .= '</ul>';
	return $output;
}

function createLeftMenu($urlbefore, $urlafter, $sec, $sub, $file) {
	if (!isset($output)) { $output = ''; }
	global $home;
	$output .=  '<ul class="leftmenu">';
	$ordner = substr($file, 0, -strlen($sub)-1);
	if (is_dir($ordner)) {
		$handle = opendir($ordner);
		while (false !== ($file = readdir($handle))) {
			if($file != "." && $file != "..") {
				$pos = strpos($file, ".DEL");
				if ($pos === false) {
					$files[] = $file;
				}
			}
		}
		natcasesort($files);
		$replace1 = array('%2F','%2C');
		$replace2 = array('/',',');
		foreach($files as $file) {
			if ($file == '01,Home') {
				$show = $home;
			} else {
				$show = substr($file, 3);
				$show = str_replace("_"," ",$show);
				$show = str_replace("SLASH","/",$show);
				$show = str_replace("AND" ,"&", $show);
			}
			if($sub != $file) {
				if(is_dir($ordner."/".$file)) {
					$output .= '<li><a href="'.$urlbefore.str_replace($replace1, $replace2, urlencode(substr($ordner,12))).'/'.str_replace($replace1, $replace2, urlencode($file)).'/01,Home'.$urlafter.'" class="leftinactive">'.htmlentities($show,ENT_QUOTES).'</a></li>';
				} else {
					$output .= '<li><a href="'.$urlbefore.str_replace($replace1, $replace2, urlencode(substr($ordner,12))).'/'.str_replace($replace1, $replace2, urlencode($file)).$urlafter.'" class="leftinactive">'.htmlentities($show,ENT_QUOTES).'</a></li>';
				}
			} else {
				if(is_dir($ordner."/".$file)) {
					$output .= '<li><a href="'.$urlbefore.str_replace($replace1, $replace2, urlencode(substr($ordner,12))).'/'.str_replace($replace1, $replace2, urlencode($file)).'/01,Home'.$urlafter.'" class="leftactive">'.htmlentities($show,ENT_QUOTES).'</a></li>';
				} else {
					$output .= '<li><a href="'.$urlbefore.str_replace($replace1, $replace2, urlencode(substr($ordner,12))).'/'.str_replace($replace1, $replace2, urlencode($file)).$urlafter.'" class="leftactive">'.htmlentities($show,ENT_QUOTES).'</a></li>';
				}
			}
		}
		closedir($handle);
		$output .= '</ul>';
		return $output;
	}
}

function createSitemap($urlbefore, $urlafter, $ordner, $count = 0, $sub = FALSE) {
	if (!isset($output)) { static $output = ''; }
	global $home;
	$vorhanden = 0;
	$handle = opendir($ordner);
	while (false !== ($file = readdir($handle))) {
		if($file != "." && $file != "..") {
			$pos = strpos($file, ".DEL");
			if ($pos === false) {
				if(is_dir($ordner."/".$file)) {
					$dirs[] = $ordner."/".$file;
					$vorhanden = 1;
				} else {
					if ($file != '01,Home') {
						$files[] = $file;
						$vorhanden = 1;
					}
				}
			}
		}
	}
	if ($vorhanden == 1) {
		$output .= '<ul class="sitemap'.$count.'">';
	}
	$replace1 = array('%2F','%2C');
	$replace2 = array('/',',');
	if($dirs) {
		natcasesort($dirs);
		foreach($dirs as $dir) {
			$file = str_replace($ordner."/","",$dir);
			if ($file == '01,Home') {
				$show = $home;
			} else {
				$show = substr($file, 3);
				$show = str_replace("_"," ",$show);
				$show = str_replace("SLASH","/",$show);
				$show = str_replace("AND" ,"&", $show);
			}
			$output .= '<li class="dirli'.$count.'"><a href="'.$urlbefore.str_replace($replace1, $replace2, urlencode(substr($ordner,12))).'/'.str_replace($replace1, $replace2, urlencode($file)).'/01,Home'.$urlafter.'" class="dirlink'.$count.'">'.htmlentities($show,ENT_QUOTES).'</a>';
			createSitemap($urlbefore, $urlafter, $dir, $count+1, TRUE, $file);
			$output .= '</li>';
		}
	}
	if($files) {
		natcasesort($files);
		foreach ($files as $file) {
			$show = substr($file, 3);
			$show = str_replace("_"," ",$show);
			$show = str_replace("SLASH","/",$show);
			$show = str_replace("AND" ,"&", $show);
			$pos = strpos($file, ".DEL");
			$output .= '<li class="fileli'.$count.'"><a href="'.$urlbefore.str_replace($replace1, $replace2, urlencode(substr($ordner,12))).'/'.str_replace($replace1, $replace2, urlencode($file)).$urlafter.'" class="filelink'.$count.'">'.htmlentities($show,ENT_QUOTES).'</a></li>';
		}
	}
	closedir($handle);
	if ($vorhanden == 1) {
		$output .= '</ul>';
	}
	return $output;
}

function createCompleteMenu($urlbefore, $urlafter, $ordner, $sec, $sub, $count = 0) {
	if (!isset($output)) { static $output = ''; }
	global $home;
	$vorhanden = 0;
	$handle = opendir($ordner);
	while (false !== ($file = readdir($handle))) {
		if($file != "." && $file != "..") {
			$pos = strpos($file, ".DEL");
			if ($pos === false) {
				if(is_dir($ordner."/".$file)) {
					$dirs[] = $ordner."/".$file;
					$vorhanden = 1;
				} else {
					if ($file != '01,Home') {
						$files[] = $file;
						$vorhanden = 1;
					}
				}
			}
		}
	}
	if ($vorhanden == 1) {
		$output .= '<ul class="menu'.$count.'">';
	}
	$replace1 = array('%2F','%2C');
	$replace2 = array('/',',');
	if($dirs) {
		natcasesort($dirs);
			foreach($dirs as $dir) {
			$file = str_replace($ordner."/","",$dir);
			if ($file == '01,Home') {
				$show = $home;
			} else {
				$show = substr($file, 3);
				$show = str_replace("_"," ",$show);
				$show = str_replace("SLASH","/",$show);
				$show = str_replace("AND" ,"&", $show);
			}
			if ($sec == $file && $sub == "01,Home") {
				$output .= '<li><a href="'.$urlbefore.str_replace($replace1, $replace2, urlencode(substr($ordner,12))).'/'.str_replace($replace1, $replace2, urlencode($file)).'/01,Home'.$urlafter.'" class="active'.$count.'">'.htmlentities($show,ENT_QUOTES).'</a>';
			} else {
				$output .= '<li><a href="'.$urlbefore.str_replace($replace1, $replace2, urlencode(substr($ordner,12))).'/'.str_replace($replace1, $replace2, urlencode($file)).'/01,Home'.$urlafter.'" class="inactive'.$count.'">'.htmlentities($show,ENT_QUOTES).'</a>';
			}
			createCompleteMenu($urlbefore, $urlafter, $dir, $sec, $sub, $count+1);
			$output .= '</li>';
		}
	}
	if($files) {
		natcasesort($files);
		foreach ($files as $file) {
			$show = substr($file, 3);
			$show = str_replace("_"," ",$show);
			$show = str_replace("SLASH","/",$show);
			$show = str_replace("AND" ,"&", $show);
			$pos = strpos($file, ".DEL");
			if ($sub != $file) {
				$output .= '<li><a href="'.$urlbefore.str_replace($replace1, $replace2, urlencode(substr($ordner,12))).'/'.str_replace($replace1, $replace2, urlencode($file)).$urlafter.'" class="inactive'.$count.'">'.htmlentities($show,ENT_QUOTES).'</a></li>';
			} else {
				$output .= '<li><a href="'.$urlbefore.str_replace($replace1, $replace2, urlencode(substr($ordner,12))).'/'.str_replace($replace1, $replace2, urlencode($file)).$urlafter.'" class="active'.$count.'">'.htmlentities($show,ENT_QUOTES).'</a></li>';
			}
		}
	}
	closedir($handle);
	if ($vorhanden == 1) {
		$output .= '</ul>';
	}
	return $output;
}

function createFoldingMenu($urlbefore, $urlafter, $ordner, $sec, $sub, $top, $count = 0, $force_folding = false) {
	if (!isset($output)) { static $output = ''; }
	global $home;
	$vorhanden = 0;
	$handle = opendir($ordner);
	while (false !== ($file = readdir($handle))) {
		if($file != "." && $file != "..") {
			$pos = strpos($file, ".DEL");
			if ($pos === false) {
				if(is_dir($ordner."/".$file)) {
					$dirs[] = $ordner."/".$file;
					$vorhanden = 1;
				} else {
					if ($file != '01,Home') {
						$files[] = $file;
						$vorhanden = 1;
					}
				}
			}
		}
	}
	if ($vorhanden == 1) {
		$output .= '<ul class="menu'.$count.'">';
	}
	$replace1 = array('%2F','%2C');
	$replace2 = array('/',',');
	if($dirs) {
		natcasesort($dirs);
		foreach($dirs as $dir) {
			if ($count == 0) {
				$force_folding = false;
			}
			$file = str_replace($ordner."/","",$dir);
			if ($file == '01,Home') {
				$show = $home;
			} else {
				$show = substr($file, 3);
				$show = str_replace("_"," ",$show);
				$show = str_replace("SLASH","/",$show);
				$show = str_replace("AND" ,"&", $show);
			}
			if (($sec == $file && $sub == "01,Home") OR $top == $file) {
				$output .= '<li><a href="'.$urlbefore.str_replace($replace1, $replace2, urlencode(substr($ordner,12))).'/'.str_replace($replace1, $replace2, urlencode($file)).'/01,Home'.$urlafter.'" class="active'.$count.'">'.htmlentities($show,ENT_QUOTES).'</a>';
			} else {
				$output .= '<li><a href="'.$urlbefore.str_replace($replace1, $replace2, urlencode(substr($ordner,12))).'/'.str_replace($replace1, $replace2, urlencode($file)).'/01,Home'.$urlafter.'" class="inactive'.$count.'">'.htmlentities($show,ENT_QUOTES).'</a>';
			}
			if ($top == $file OR $force_folding == true) {
				createFoldingMenu($urlbefore, $urlafter, $dir, $sec, $sub, $top, $count+1, $force_folding = true);
			}
			$output .= '</li>';
		}
	}
	if($files) {
		natcasesort($files);
		foreach ($files as $file) {
			$show = substr($file, 3);
			$show = str_replace("_"," ",$show);
			$show = str_replace("SLASH","/",$show);
			$show = str_replace("AND" ,"&", $show);
			$pos = strpos($file, ".DEL");
			if ($sub != $file) {
				$output .= '<li><a href="'.$urlbefore.str_replace($replace1, $replace2, urlencode(substr($ordner,12))).'/'.str_replace($replace1, $replace2, urlencode($file)).$urlafter.'" class="inactive'.$count.'">'.htmlentities($show,ENT_QUOTES).'</a></li>';
			} else {
				$output .= '<li><a href="'.$urlbefore.str_replace($replace1, $replace2, urlencode(substr($ordner,12))).'/'.str_replace($replace1, $replace2, urlencode($file)).$urlafter.'" class="active'.$count.'">'.htmlentities($show,ENT_QUOTES).'</a></li>';
			}
		}
	}
	closedir($handle);
	if ($vorhanden == 1) {
		$output .= '</ul>';
	}
	return $output;
}

function PageCount($file) {
	$filename = str_replace("SLASH","SCHRAEG",$file);
	$filename = str_replace("/","SLASH",$filename);
	if (is_file($filename)) {
		if (file_exists('counter/'.$filename)) {
			$handle = fopen('counter/'.$filename, "r+");
			$count = fread($handle, 1024);
			$count++;
			rewind($handle);
			fwrite($handle, $count);
			fclose($handle);
			$output = $count;
		} else {
			$handle = fopen('counter/'.$filename, "w+");
			fwrite($handle, "1");
			fclose($handle);
			$output = '1';
		}
	} else {
		$output = 'unbekannt';
	}
	return $output;
}
function LastEdit() {
	if ($_GET['special'] != 'search' && file_exists($file)) {
		$filetime = filemtime($file);
		if($filetime == false) {
			$LastEdit = "-";
		} else {
			$LastEdit = date("d.m.Y H:i", $filetime);
		}
	} else {
		$LastEdit = '-';
	}
	return $LastEdit;
}

function doSearch($keyword, $folder = './data/pages') {
	global $home;
	global $urlbefore;
	global $urlafter;
	if (!isset($found)) {
		static $found = false;
	}
	if (!isset($search_matches)) {
		static $search_matches = '';
	}
	if ($keyword != '' && $keyword != ' ') {
		$handle = opendir($folder);
		while (false !== ($file = readdir ($handle))) {
			if ($file != "." && $file != "..") {
				if (is_file($folder.'/'.$file)) {
					$content = file_get_contents($folder.'/'.$file);
					$content = strip_tags($content);
					$content = preg_replace('/%%(.*)%%/', '', $content);
					$content = trim($content);
					$pos1 = stripos($content, $keyword);
					$pos2 = stripos(htmlentities($content), $keyword);
					if ($pos1 !== false OR $pos2 !== false) {
						$found = true;

						$pagetitle = '';
						$title_temp = substr($folder.'/'.$file, 13);
						$title = explode("/", $title_temp);
						$first = 1;
						foreach($title as $text) {
							if ($first == 0) {
								$pagetitle .= ' &gt; ';
							}
							if ($text == '01,Home') {
								$text = $home;
							} else {
								$text = substr($text, 3);
								$text = str_replace("_"," ",$text);
								$text = str_replace("SLASH","/",$text);
								$text = str_replace("AND","&",$text);
							}
							$pagetitle .= htmlentities($text);
							$first = 0;
						}
						$pagetitle = str_replace(' &gt; '.$home, '', $pagetitle);
						$pagetitle = str_replace('.DEL', '', $pagetitle);

						$url = substr($folder.'/'.$file, 12);
						$replace1 = array('%2F','%2C');
						$replace2 = array('/',',');
						$url = str_replace($replace1, $replace2, urlencode($url));
						$url = $urlbefore.$url.$urlafter;
						
						if (strlen($content) > 200) {
							$preview = substr($content, 0, 200).'...';
						} else {
							$preview = $content;
						}
						$search_matches .= '<a href="'.$url.'">'.$pagetitle.'</a><br />'.$preview.'<br /><br />';
					}
				} else {
					doSearch($keyword, $folder.'/'.$file);
				}
			}
		}
		closedir($handle);
		$output = '';
		if ($found == true) {
			$output .= '<p>Zu Ihrer Suchanfrage "'.htmlentities($keyword).'" wurden folgende Ergebnisse gefunden:</p>';
			$output .= '<p>'.$search_matches.'</p>';
		} elseif ($found == false) {
			$output .= '<p>Zu ihrer Suchanfrage "'.htmlentities($keyword).'" wurden keine Suchergebnisse gefunden.<br /><i>Gro&szlig;- und Kleinschreibung wird nicht ber&uuml;cksichtigt.</i></p>';
		}
	} else {
		$output .= 'Bitte ein Suchwort eingeben.';
	}
	return $output;
}
?>