<?php
/*  cms-db  Copyright (C) 2007-2008 Jan Hoffmann
    This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
    This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details.  */
include('checkuser.inc.php');
checkuser('root');
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>CMS Inhalt</title>
<link rel="stylesheet" type="text/css" href="style.css">
</head>
<body>
<?php
if (isset($_POST["submit"])) {
	
	echo '<h1>Backup hochladen</h1>';

	if (is_uploaded_file($_FILES["file"]["tmp_name"])) {
		
		if (substr($_FILES["file"]["name"], -4, 4) == '.zip') {
	
			if (copy($_FILES["file"]["tmp_name"], '../data/backup/'.$_FILES["file"]["name"])) {
			
				include("./pclzip-2-6/pclzip.lib.php");
				
				$zip = new PclZip('../data/backup/'.$_FILES["file"]["name"]);
				$prop = $zip->properties();
				if ($prop['status'] == 'ok') {
					
					$list = $zip->listContent();
					
					$signature = explode('/', $list[0]['filename']);
					$signature = $signature[0];
					
					if ($signature == 'cms-db_backup_pages_v0.4') {
						echo '<p>Backup-Typ: Seiten-Backup</p>';
						$result = $zip->extract(PCLZIP_OPT_PATH, '../data/pages',
							PCLZIP_OPT_REMOVE_PATH, $signature,
							PCLZIP_OPT_REPLACE_NEWER);
						if ($result == 0) {
							die('<p>Fehler: '.$archive->errorInfo().'</p>');
						}
						echo '<p>';
						for ($i=0; $i<sizeof($result); $i++) {
							echo 'extracting &quot;'.$result[$i]['stored_filename'].'&quot; to &quot;'.$result[$i]['filename'].'&quot; ... '.$result[$i]['status'].'<br />';
						}
						echo '</p>';
						echo '<p>Das Backup wurde entpackt.</p>';
						unlink('../data/backup/'.$_FILES["file"]["name"]);
					} elseif ($signature == 'cms-db_backup_files_v0.4') {
						echo 'Backup-Typ: Datei-Backup';
						$result = $zip->extract(PCLZIP_OPT_PATH, '../data/files',
							PCLZIP_OPT_REMOVE_PATH, $signature,
							PCLZIP_OPT_REPLACE_NEWER);
						if ($result == 0) {
							die('<p>Fehler: '.$archive->errorInfo().'</p>');
						}
						echo '<p>';
						for ($i=0; $i<sizeof($result); $i++) {
							echo 'extracting &quot;'.$result[$i]['stored_filename'].'&quot; to &quot;'.$result[$i]['filename'].'&quot; ... '.$result[$i]['status'].'<br />';
						}
						echo '</p>';
						echo '<p>Das Backup wurde entpackt.</p>';
						unlink('../data/backup/'.$_FILES["file"]["name"]);
					} elseif ($signature == 'cms-db_backup_includes_v0.4') {
						echo 'Backup-Typ: Include-Backup';
						$result = $zip->extract(PCLZIP_OPT_PATH, '../data/includes',
							PCLZIP_OPT_REMOVE_PATH, $signature,
							PCLZIP_OPT_REPLACE_NEWER);
						if ($result == 0) {
							die('<p>Fehler: '.$archive->errorInfo().'</p>');
						}
						echo '<p>';
						for ($i=0; $i<sizeof($result); $i++) {
							echo 'extracting &quot;'.$result[$i]['stored_filename'].'&quot; to &quot;'.$result[$i]['filename'].'&quot; ... '.$result[$i]['status'].'<br />';
						}
						echo '</p>';
						echo '<p>Das Backup wurde entpackt.</p>';
						unlink('../data/backup/'.$_FILES["file"]["name"]);
					} elseif ($signature == 'cms-db_backup_gb-tpl_v0.4') {
						echo 'Backup-Typ: G&auml;stebuch- und Template-Backup';
						$result = $zip->extract(PCLZIP_OPT_PATH, '../data',
							PCLZIP_OPT_REMOVE_PATH, $signature,
							PCLZIP_OPT_REPLACE_NEWER);
						if ($result == 0) {
							die('<p>Fehler: '.$archive->errorInfo().'</p>');
						}
						echo '<p>';
						for ($i=0; $i<sizeof($result); $i++) {
							echo 'extracting &quot;'.$result[$i]['stored_filename'].'&quot; to &quot;'.$result[$i]['filename'].'&quot; ... '.$result[$i]['status'].'<br />';
						}
						echo '</p>';
						echo '<p>Das Backup wurde entpackt.</p>';
						unlink('../data/backup/'.$_FILES["file"]["name"]);
					} elseif ($signature == 'cms-db_backup_complete_v0.5') {
						echo 'Backup-Typ: Komplettes Backup';
						$result = $zip->extract(PCLZIP_OPT_PATH, '../data',
							PCLZIP_OPT_REMOVE_PATH, $signature,
							PCLZIP_OPT_REPLACE_NEWER);
						if ($result == 0) {
							die('<p>Fehler: '.$archive->errorInfo().'</p>');
						}
						echo '<p>';
						for ($i=0; $i<sizeof($result); $i++) {
							echo 'extracting &quot;'.$result[$i]['stored_filename'].'&quot; to &quot;'.$result[$i]['filename'].'&quot; ... '.$result[$i]['status'].'<br />';
						}
						echo '</p>';
						echo '<p>Das Backup wurde entpackt.</p>';
						unlink('../data/backup/'.$_FILES["file"]["name"]);
					} else {
						echo '<p>Das hochgeladene Archiv ist kein cms -db-Backup (Das Backup muss in Version 0.4 vorliegen).</p>';
						unlink('../data/backup/'.$_FILES["file"]["name"]);
					}
					echo '<p><a href="backup_unzip.php?'.SID.'">zur&uuml;ck</a></p>';
					
				} else {
					echo '<p>Das hochgeladene Archiv ist defekt. (Fehler: '.$zip->errorInfo().')</p><p><a href="backup_unzip.php?'.SID.'">zur&uuml;ck</a></p>';
					unlink('../data/backup/'.$_FILES["file"]["name"]);
				}
				
			} else {
				echo '<p>Datei konnte nicht kopiert werden.</p><p><a href="backup_unzip.php?'.SID.'">zur&uuml;ck</a></p>';
			}
			
		} else {
			echo '<p>Die Datei besitzt eine ung&uuml;ltige Endung. Sie muss mit &quot;.zip&quot; enden.</p><p><a href="backup_unzip.php?'.SID.'">zur&uuml;ck</a></p>';
		}

	} else {
		echo '<p>Es wurde keine Datei hochgeladen. M&ouml;glicherweise &uuml;berschreitet die Gr&ouml;&szlig;e der Datei die Maximal-Upload-Gr&ouml;&szlig;e von PHP.</p><p><a href="backup_unzip.php?'.SID.'">zur&uuml;ck</a></p>';
	}

} else {
?>
<h1>Backup hochladen</h1>
<p>
	Bitte eine Datei w&auml;hlen:
</p>
<p>
	<form action="backup_unzip.php?<?php echo SID ?>" method="post" enctype="multipart/form-data" name="upload">
	<input type="file" name="file"><br>
	<input type="submit" name="submit" value="Backup hochladen und installieren">
	</form>
</p>
<p>
	<i>
		Hinweis: Bereits bestehende Seiten, Dateien, Includes, G&auml;stebucheintr&auml;ge und das Template werden beim Hochladen des Backups evtl. &uuml;berschrieben.<br />
		Um Fehlfunktionen zu vermeiden wird empfohlen, alle Seiten vor dem Entpacken eines Seiten-Backups zu l&ouml;schen.
	</i>
</p>
<p>
	<i>
		Sie k&ouml;nnen Backups auch manuell hochladen. Laden Sie dazu Inhalt des Ordners cms-db_backup_* des ZIP-Archivs in den richtigen Ordner hoch:<br />
		Seiten-Backup: /data/pages<br />
		Datei-Backup: /data/files<br />
		Include-Backup: /data/includes<br />
		G&auml;stebuch- und Template-Backup: /data<br />
		Komplettes Backup: /data
	</i>
</p>
<?php
}
?>
</body>
</html>