<?php
/*  cms-db  Copyright (C) 2007-2008 Jan Hoffmann
    This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
    This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details.  */
include("../data/settings/admin.inc.php");
include('checkuser.inc.php');
checkuser('');
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1" />
		<title>cms -db Adminbereich</title>
		<style type="text/css" media="screen">
		/*<![CDATA[*/
		* {
			font-family: Century Gothic,URW Gothic L,Arial,Helvetica,sans-serif;
			font-size: 10pt;
		}
		body {
			margin-top: 24px;
			margin-left: 0px;
			margin-right: 0px;
			margin-bottom: 0px;
			background-color: rgb(<?php echo $bg_r ?>,<?php echo $bg_g ?>,<?php echo $bg_b ?>);
			color: rgb(<?php echo $text_r ?>,<?php echo $text_g ?>,<?php echo $text_b ?>);
		}
		#bar {
			background-color: #eeeeee;
			background-image: url("top.png");
			background-repeat: repeat-x;
			position: fixed;
			top: 0px;
			left: 0px;
			right: 0px;
			padding-top: 0px;
			padding-left: 5px;
			padding-right: 5px;
			padding-bottom: 0px;
			height: 24px;
		}
		.barinactive {
			background-color: transparent;
			color: #000000;
			font-size: 10pt;
			font-family: Century Gothic,URW Gothic L,Arial,Helvetica,sans-serif;
			text-decoration: none;
			height: 24px;
			width: 50px;
			text-align: center;
		}
		.baractive {
			background-color: rgb(<?php echo $bg_r ?>,<?php echo $bg_g ?>,<?php echo $bg_b ?>);
			background-image: url("bg_menu.png");
			background-repeat: no-repeat;
			color: #000000;
			font-size: 10pt;
			font-family: Century Gothic,URW Gothic L,Arial,Helvetica,sans-serif;
			text-decoration: none;
			height: 24px;
			width: 50px;
			text-align: center;
		}
		#menu {
			background-color: #ffffff;
			color: #000000;
			font-size: 10pt;
			font-family: Century Gothic,URW Gothic L,Arial,Helvetica,sans-serif;
			text-decoration: none;
			width: 200px;
			position: fixed;
			top: 23px;
			left: 5px;
			border: 1px solid #999999;
		}
		.menuinactive {
			display: block;
			background-color: transparent;
			color: #000000;
			font-size: 10pt;
			font-family: Century Gothic,URW Gothic L,Arial,Helvetica,sans-serif;
			text-decoration: none;
			padding-left: 5px;
			padding-right: 5px;
			height: 24px;
		}
		.menuactive {
			display: block;
			background-color: rgb(<?php echo $bg_r ?>,<?php echo $bg_g ?>,<?php echo $bg_b ?>);
			background-image: url("bg_menuitem.png");
			background-repeat: no-repeat;
			color: #000000;
			font-size: 10pt;
			font-family: Century Gothic,URW Gothic L,Arial,Helvetica,sans-serif;
			text-decoration: none;
			padding-left: 5px;
			padding-right: 5px;
			height: 24px;
		}
		#desktop {
			padding: 10px;
		}
		.button {
			text-decoration:none;
			background-color: transparent;
		}
		.button>img {
			vertical-align: top;
		}
		.buttoninactive {
			padding-top: 4px;
			padding-left: 2px;
			padding-right: 2px;
			padding-bottom: 4px;
			width: 16px;
			height: 16px;
			background-color: transparent;
		}
		.buttonactive {
			padding-top: 4px;
			padding-left: 2px;
			padding-right: 2px;
			padding-bottom: 4px;
			width: 16px;
			height: 16px;
			background-color: rgb(<?php echo $bg_r ?>,<?php echo $bg_g ?>,<?php echo $bg_b ?>);
			background-image: url("bg_button.png");
			background-repeat: no-repeat;
		}
		#time {
			color: #000000;
		}
		#date {
			position: fixed;
			top: 23px;
			right: 4px;
			border: 1px solid #999999;
			color: #000000;
			background-color: #ffff99;
			padding-top: 0px;
			padding-left: 2px;
			padding-right: 2px;
			padding-bottom: 0px;
		}
		/*]]>*/
		</style>
		<style type="text/css" media="screen">
		/*<![CDATA[*/
		#icons img {
			border: none;
			vertical-align: bottom;
		}
		#icons a {
			text-decoration: none;
		}
		#iconcontainer {
			position: fixed;
			left: 0px;
			right: 0px;
			bottom: 0px;
			height: 1px;
			overflow: visible;
			text-align: justify;
			visibility: hidden;
		}
		#icons {
			height: 50px;
			margin: -49px auto 0 auto;
			width: 410px;
			text-align: center;
			background-image: url("bottom-bg.png");
			background-repeat: repeat-x;
			background-position: bottom;
		}
		/*]]>*/
		</style>
		<style type="text/css">
		/*<![CDATA[*/
		#horizon-warning {
			position: fixed;
			top: 50%;
			left: 0;
			width: 100%;
			height: 1px;
			overflow: visible;
			visibility: visible;
			display: block;
			text-align: justify;
			display: none;
		}
		#warning {
			background-color: #fff;
			text-align: left;
			width: 45em;
			min-height: 128px;
			margin: -64px auto 0 auto;
			border: 2px outset #aaa;
			color: #000;
		}
		#warning input {
			background-color: #ddd;
			border: 2px outset #ccc;
		}
		/*]]>*/
		</style>
		<script src="top.js" type="text/javascript" language="JavaScript"></script>
		<script src="bottom.js" type="text/javascript" language="JavaScript"></script>
		<script src="warning.js" type="text/javascript" language="JavaScript"></script>
	</head>
	<body onLoad="init();window.onresize=init">

		<div id="all" style="visibility:hidden">
			<div id="desktop">
				<?php if ($view == 'menu') { ?>
				<a href="pages.php?<?php echo SID ?>" target="iframe" onmouseover="document.getElementById('buttontext').firstChild.nodeValue='Seitenverwaltung'" onmouseout="document.getElementById('buttontext').firstChild.nodeValue='&nbsp;'" onclick="showiframe();hidemenu()" title="Seitenverwaltung" style="text-decoration:none">
					<img src="big-icons/pages.png" alt="Seitenverwaltung" width="48" height="48" style="border:none" />
				</a>
				&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
				<a href="files.php?<?php echo SID ?>" target="iframe" onmouseover="document.getElementById('buttontext').firstChild.nodeValue='Dateiverwaltung'" onmouseout="document.getElementById('buttontext').firstChild.nodeValue='&nbsp;'"  onclick="showiframe();hidemenu()" title="Dateiverwaltung" style="text-decoration:none">
					<img src="big-icons/files.png" alt="Dateiverwaltung" width="48" height="48" style="border:none" />
				</a>
				&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
				<a href="includes.php?<?php echo SID ?>" target="iframe" onmouseover="document.getElementById('buttontext').firstChild.nodeValue='Verwaltung von Include-Dateien'" onmouseout="document.getElementById('buttontext').firstChild.nodeValue='&nbsp;'" onclick="showiframe();hidemenu()" title="Verwaltung von Include-Dateien" style="text-decoration:none">
					<img src="big-icons/includes.png" alt="Verwaltung von Include-Dateien" width="48" height="48" style="border:none" />
				</a>
				&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
				<a href="settings.php?<?php echo SID ?>" target="iframe" onmouseover="document.getElementById('buttontext').firstChild.nodeValue='Einstellungen &auml;ndern'" onmouseout="document.getElementById('buttontext').firstChild.nodeValue='&nbsp;'" onclick="showiframe();hidemenu()" title="Einstellungen &auml;ndern" style="text-decoration:none">
					<img src="big-icons/settings.png" alt="Einstellungen &auml;ndern" width="48" height="48" style="border:none" />
				</a>
				&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
				<a href="template.php?<?php echo SID ?>" target="iframe" onmouseover="document.getElementById('buttontext').firstChild.nodeValue='Template/Design bearbeiten'" onmouseout="document.getElementById('buttontext').firstChild.nodeValue='&nbsp;'" onclick="showiframe();hidemenu()" title="Template/Design bearbeiten" style="text-decoration:none">
					<img src="big-icons/template.png" alt="Template/Design bearbeiten" width="48" height="48" style="border:none" />
				</a>
				&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
				<a href="space.php?<?php echo SID ?>" target="iframe" onmouseover="document.getElementById('buttontext').firstChild.nodeValue='Speicherplatzinformationen'" onmouseout="document.getElementById('buttontext').firstChild.nodeValue='&nbsp;'" onclick="showiframe();hidemenu()" title="Speicherplatzinformation" style="text-decoration:none">
					<img src="big-icons/space.png" alt="Speicherplatzinformationen" width="48" height="48" style="border:none" />
				</a>
				&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
				<a href="fileperms.php?<?php echo SID ?>" target="iframe" onmouseover="document.getElementById('buttontext').firstChild.nodeValue='Dateirechteverwaltung'" onmouseout="document.getElementById('buttontext').firstChild.nodeValue='&nbsp;'" onclick="showiframe();hidemenu()" title="Dateirechteverwaltung" style="text-decoration:none">
					<img src="big-icons/fileperms.png" alt="Dateirechteverwaltung" width="48" height="48" style="border:none" />
				</a>
				&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
				<a href="backup.php?<?php echo SID ?>" target="iframe" onmouseover="document.getElementById('buttontext').firstChild.nodeValue='Sicherheitskopien erstellen'" onmouseout="document.getElementById('buttontext').firstChild.nodeValue='&nbsp;'" onclick="showiframe();hidemenu()" title="Sicherheitskopien erstellen" style="text-decoration:none">
					<img src="big-icons/backup.png" alt="Sicherheitskopien erstellen" width="48" height="48" style="border:none" />
				</a>
				&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
				<a href="guestbook.php?<?php echo SID ?>" target="iframe" onmouseover="document.getElementById('buttontext').firstChild.nodeValue='G&auml;stebucheintr&auml;ge l&ouml;schen'" onmouseout="document.getElementById('buttontext').firstChild.nodeValue='&nbsp;'" onclick="showiframe();hidemenu()" title="G&auml;stebucheintr&auml;ge l&ouml;schen" style="text-decoration:none">
					<img src="big-icons/guestbook.png" alt="G&auml;stebucheintr&auml;ge l&ouml;schen" width="48" height="48" style="border:none" />
				</a>
				&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
				<a href="stats.php?<?php echo SID ?>" target="iframe" onmouseover="document.getElementById('buttontext').firstChild.nodeValue='Browser- und Betriebssystem-Statistik ansehen'" onmouseout="document.getElementById('buttontext').firstChild.nodeValue='&nbsp;'" onclick="showiframe();hidemenu()" title="Browser- und Betriebssystem-Statistik ansehen" style="text-decoration:none">
					<img src="big-icons/stats.png" alt="Statistik" width="48" height="48" style="border:none" />
				</a>
				&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
				<a href="recyclebin.php?<?php echo SID ?>" target="iframe" onmouseover="document.getElementById('buttontext').firstChild.nodeValue='Gel&ouml;schte Objekte wiederherstellen'" onmouseout="document.getElementById('buttontext').firstChild.nodeValue='&nbsp;'" onclick="showiframe();hidemenu()" title="Gel&ouml;schte Objekte wiederherstellen" style="text-decoration:none">
					<img src="big-icons/recyclebin.png" alt="Recycling-Center" width="48" height="48" style="border:none" />
				</a>
				<br />
				<span id="buttontext" style="font-weight:bold;font-size:15px">&nbsp;</span>
				<?php } ?>
				<?php
				if (ini_get('safe_mode')) {
					echo '<br /><br />Es m&uuml;ssen Angaben bei den FTP-Einstellungen eingestellt werden!<br><a href="ftpsettings.php" target="iframe" onClick="showiframe();hidemenu()">einstellen</a>';
				}
				?>
			</div>
			<iframe src="about:blank" id="iframe" name="iframe" height="400" width="700" style="border:none;display:none;background-color:#ffffff"></iframe>
			<div id="bar">
				<?php if ($view == 'menu') { ?>
				<a href="#" onMouseOver="baractive('bar-menu')" onMouseOut="bar('bar-menu')" onMouseDown="switchmenu()" id="bar-menu" class="barinactive" style="float:left">Men&uuml;</a>
				<?php } ?>
				<div style="float:right">
<?php if ($_GET['mode'] != 'splitleft' && $_GET['mode'] != 'splitright') { ?>
					<a href="frame2.php?<?php echo SID ?>" class="button">
						<img src="split.png" width="16" height="16" alt="Ansicht teilen" title="Ansicht teilen" style="border:none" id="split" onMouseOver="buttonactive('split')" onMouseOut="buttoninactive()" class="buttoninactive" />
					</a>
<?php } ?>
					<a href="../" target="iframe" onClick="showiframe();hidemenu()" class="button">
						<img src="preview.png" width="16" height="16" alt="Webseitenvorschau" title="Webseitenvorschau" style="border:none" id="preview" onMouseOver="buttonactive('preview')" onMouseOut="buttoninactive()" class="buttoninactive" />
					</a>
					<a href="version.php" target="iframe" onClick="showiframe();hidemenu()" class="button">
						<img src="info.png" width="16" height="16" alt="&Uuml;ber cms -db" title="&Uuml;ber cms -db" style="border:none" id="info" onMouseOver="buttonactive('info')" onMouseOut="buttoninactive()" class="buttoninactive" />
					</a>
					<a href="#" onClick="hideiframe();hidemenu()" id="close" class="button">
						<img src="close.png" width="16" height="16" alt="Schlie&szlig;en" title="Schlie&szlig;en" style="border:none" id="closeb" onMouseOver="buttonactive('closeb')" onMouseOut="buttoninactive()" class="buttoninactive" />
					</a>
<?php if ($_GET['mode'] != 'splitleft') { ?>
					<a href="javascript:showWarning()" target="_top" class="button">
						<img src="logout.png" width="16" height="16" alt="Adminbereich verlassen" title="Adminbereich verlassen" style="border:none" id="logout" onMouseOver="buttonactive('logout')" onMouseOut="buttoninactive()" class="buttoninactive" />
					</a>
					<span id="time" onmouseover="setDateVisible()" onmouseout="setDateInvisible()">00:00</span>
					<span id="date">Tag, 0. Monat 0000</span>
<?php } else { ?>
					<a href="frame.php?<?php echo SID ?>" target="_top" class="button">
						<img src="unsplit.png" width="16" height="16" alt="Teilung aufheben" title="Teilung aufheben" style="border:none" id="unsplit" onMouseOver="buttonactive('unsplit')" onMouseOut="buttoninactive()" class="buttoninactive" />
					</a>
<?php } ?>
				</div>
			</div>
			<div id="menu" style="display:none">
				<a href="pages.php?<?php echo SID ?>" target="iframe" onClick="hidemenu();showiframe()" onMouseOver="menuactive('menu-pages')" onMouseOut="menuinactive()" id="menu-pages" class="menuinactive">Seiten</a>
				<a href="files.php?<?php echo SID ?>" target="iframe" onClick="hidemenu();showiframe()" onMouseOver="menuactive('menu-files')" onMouseOut="menuinactive()" id="menu-files" class="menuinactive">Dateien</a>
				<a href="includes.php?<?php echo SID ?>" target="iframe" onClick="hidemenu();showiframe()" onMouseOver="menuactive('menu-includes')" onMouseOut="menuinactive()" id="menu-includes" class="menuinactive">Includes</a>
				<a href="settings.php?<?php echo SID ?>" target="iframe" onClick="hidemenu();showiframe()" onMouseOver="menuactive('menu-settings')" onMouseOut="menuinactive()" id="menu-settings" class="menuinactive">Einstellungen</a>
				<a href="template.php?<?php echo SID ?>" target="iframe" onClick="hidemenu();showiframe()" onMouseOver="menuactive('menu-template')" onMouseOut="menuinactive()" id="menu-template" class="menuinactive">Template</a>
				<a href="space.php?<?php echo SID ?>" target="iframe" onClick="hidemenu();showiframe()" onMouseOver="menuactive('menu-space')" onMouseOut="menuinactive()" id="menu-space" class="menuinactive">Speicherplatz</a>
				<a href="fileperms.php?<?php echo SID ?>" target="iframe" onClick="hidemenu();showiframe()" onMouseOver="menuactive('menu-perms')" onMouseOut="menuinactive()" id="menu-perms" class="menuinactive">Datei-Rechte</a>
				<a href="backup.php?<?php echo SID ?>" target="iframe" onClick="hidemenu();showiframe()" onMouseOver="menuactive('menu-backup')" onMouseOut="menuinactive()" id="menu-backup" class="menuinactive">Backups</a>
				<a href="guestbook.php?<?php echo SID ?>" target="iframe" onClick="hidemenu();showiframe()" onMouseOver="menuactive('menu-gbook')" onMouseOut="menuinactive()" id="menu-gbook" class="menuinactive">G&auml;stebuch</a>
				<a href="stats.php?<?php echo SID ?>" target="iframe" onClick="hidemenu();showiframe()" onMouseOver="menuactive('menu-stats')" onMouseOut="menuinactive()" id="menu-stats" class="menuinactive">Statistik</a>
				<a href="recyclebin.php?<?php echo SID ?>" target="iframe" onClick="hidemenu();showiframe()" onMouseOver="menuactive('menu-recyclebin')" onMouseOut="menuinactive()" id="menu-recyclebin" class="menuinactive">Recycling-Center</a>
			</div>
		</div>
		<div id="javascript" style="padding-left: 10px">
			Ihr Browser unterst&uuml;tzt leider kein JavaScript bzw. es ist deaktiviert.<br />
			<a href="quirks-mode.php<?php echo SID ?>" style="color: rgb(<?php echo $text_r ?>,<?php echo $text_g ?>,<?php echo $text_b ?>)">
				Klicken Sie hier f&uuml;r eine alternative Version von <span style="font-family: FreeMono,Courier,monospace; font-weight: bold">cms </span><span style="color: #ff0000; font-family: FreeMono,Courier,monospace; font-weight: bold">-db</span> ohne JavaScript.
			</a>
		</div>
		
		<?php if ($view == 'icons') { ?>
		<div id="iconcontainer">
			<div id="icons">
				<a href="pages.php?<?php echo SID ?>" target="iframe" onclick="showiframe();hidemenu()" onmouseover="makeIconActive('pages')" onmouseout="makeIconInactive('pages')" title="Seitenverwaltung">
					<img id="pages" src="./big-icons/pages.png" width="32" height="32" alt="Seitenverwaltung" />
				</a>
				<a href="files.php?<?php echo SID ?>" target="iframe" onclick="showiframe();hidemenu()" onmouseover="makeIconActive('files')" onmouseout="makeIconInactive('files')" title="Dateiverwaltung">
					<img id="files" src="./big-icons/files.png" width="32" height="32" alt="Dateiverwaltung" />
				</a>
				<a href="includes.php?<?php echo SID ?>" target="iframe" onclick="showiframe();hidemenu()" onmouseover="makeIconActive('includes')" onmouseout="makeIconInactive('includes')" title="Includes">
					<img id="includes" src="./big-icons/includes.png" width="32" height="32" alt="Includes" />
				</a>
				<a href="settings.php?<?php echo SID ?>" target="iframe" onclick="showiframe();hidemenu()" onmouseover="makeIconActive('settings')" onmouseout="makeIconInactive('settings')" title="Einstellungen">
					<img id="settings" src="./big-icons/settings.png" width="32" height="32" alt="Einstellungen" />
				</a>
				<a href="template.php?<?php echo SID ?>" target="iframe" onclick="showiframe();hidemenu()" onmouseover="makeIconActive('template')" onmouseout="makeIconInactive('template')" title="Design/Template &auml;ndern">
					<img id="template" src="./big-icons/template.png" width="32" height="32" alt="Design/Template &auml;ndern" />
				</a>
				<a href="space.php?<?php echo SID ?>" target="iframe" onclick="showiframe();hidemenu()" onmouseover="makeIconActive('space')" onmouseout="makeIconInactive('space')" title="Speicherplatz">
					<img id="space" src="./big-icons/space.png" width="32" height="32" alt="Speicherplatz" />
				</a>
				<a href="fileperms.php?<?php echo SID ?>" target="iframe" onclick="showiframe();hidemenu()" onmouseover="makeIconActive('fileperms')" onmouseout="makeIconInactive('fileperms')" title="Dateirechte">
					<img id="fileperms" src="./big-icons/fileperms.png" width="32" height="32" alt="Dateirechte" />
				</a>
				<a href="backup.php?<?php echo SID ?>" target="iframe" onclick="showiframe();hidemenu()" onmouseover="makeIconActive('backup')" onmouseout="makeIconInactive('backup')" title="Sicherheitskopien">
					<img id="backup" src="./big-icons/backup.png" width="32" height="32" alt="Sicherheitskopien" />
				</a>
				<a href="guestbook.php?<?php echo SID ?>" target="iframe" onclick="showiframe();hidemenu()" onmouseover="makeIconActive('guestbook')" onmouseout="makeIconInactive('guestbook')" title="G&auml;stebuch">
					<img id="guestbook" src="./big-icons/guestbook.png" width="32" height="32" alt="G&auml;stebuch" />
				</a>
				<a href="stats.php?<?php echo SID ?>" target="iframe" onclick="showiframe();hidemenu()" onmouseover="makeIconActive('stats')" onmouseout="makeIconInactive('stats')" title="Betriebssystem- und Browser-Statistiken">
					<img id="stats" src="./big-icons/stats.png" width="32" height="32" alt="Betriebssystem- und Browser-Statistiken" />
				</a>
				<a href="recyclebin.php?<?php echo SID ?>" target="iframe" onclick="showiframe();hidemenu()" onmouseover="makeIconActive('recyclebin')" onmouseout="makeIconInactive('recyclebin')" title="Recycling-Center">
					<img id="recyclebin" src="./big-icons/recyclebin.png" width="32" height="32" alt="Recycling-Center" />
				</a>
				<img src="transparent.png" width="1" height="50" alt="" />
			</div>
		</div>
		<?php } ?>

		<div id="horizon-warning">
			<div id="warning">
				<img src="important.png" width="128" height="128" alt="Warnung" title="Warnung" style="float: left" />
				<p>
					M&ouml;chten Sie den Adminbereich von cms -db wirklich verlassen?<br />
					Alle ungespeicherten &Auml;nderungen gehen verloren und der komplette Inhalt des Recycling-Centers wird unwiderruflich gel&ouml;scht!
				</p>
				<div style="text-align: center">
					<form action="logout.php<?php echo SID ?>" method="POST" style="display: inline">
						<input type="submit" value="JA" />
					</form>
					<form action="#" method="POST" onsubmit="return hideWarning();" style="display: inline">
						<input type="submit" value="NEIN" />
					</form>
				</div>
			</div>
		</div>
		
		<!--[if lt IE 8]>
		<div style="padding-left: 10px; display: none" id="ie">
			<script type="text/javascript">
			if (document.getElementById("iconcontainer")) {
				document.getElementById("iconcontainer").style.display = "none";
			}
			document.getElementById("all").style.display = "none";
			document.getElementById("ie").style.display = "block";
			function view() {
				if (document.getElementById("iconcontainer")) {
					document.getElementById("iconcontainer").style.display = "block";
				}
				document.getElementById("all").style.display = "block";
				document.getElementById("ie").style.display = "none";
			}
			</script>
			Ihr Browser unterst&uuml;tzt <span style="font-family: FreeMono,Courier,monospace; font-weight: bold">cms </span><span style="color: #ff0000; font-family: FreeMono,Courier,monospace; font-weight: bold">-db</span> nicht vollst&auml;ndig. Sie haben nun folgende M&ouml;glichkeiten:<br />
			&nbsp;-&nbsp;<a href="http://www.mozilla-europe.org/de/products/firefox/" style="color: rgb(<?php echo $text_r ?>,<?php echo $text_g ?>,<?php echo $text_b ?>)">
				Verwenden Sie einen besseren Browser (empfohlen)
			</a><br />
			&nbsp;-&nbsp;<a href="quirks-mode.php<?php echo SID ?>" style="color: rgb(<?php echo $text_r ?>,<?php echo $text_g ?>,<?php echo $text_b ?>)">
				Verwenden Sie die Kompatibilit&auml;tsversion
			</a><br />
			&nbsp;-&nbsp;<a href="javascript:view();" style="color: rgb(<?php echo $text_r ?>,<?php echo $text_g ?>,<?php echo $text_b ?>)">
				Verwenden Sie die Vollversion mit Einschr&auml;nkungen
			</a>
		</div>
		<![endif]-->

	</body>
</html>