<?php
/*  cms-db  Copyright (C) 2007-2008 Jan Hoffmann
    This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
    This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details.  */
include('checkuser.inc.php');
checkuser('');
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>CMS Inhalt</title>
<link rel="stylesheet" type="text/css" href="style.css">
</head>
<body>

<h1>Statistik</h1>
<p>
	Hier k&ouml;nnen Sie sich ansehen, mit welchen Browsern und Betriebssystemen Ihre Website besucht wird.
</p>
<h2>Browser</h2>
<table style="width: 750px; border-collapse: collapse">
	<tbody>
<?php
$browser_files= array();
$browser_count = 0;
$folder = '../data/stats/browser';
$handle = opendir($folder);
while (false !== ($file = readdir($handle))) {
	if($file != "." && $file != "..") {
		if (!isset($_GET['nobots'])) {
			$browser_files[] = file_get_contents('../data/stats/browser/'.$file);
		} else {
			if (substr($file, 0, 3) != 'bot') {
				$browser_files[] = file_get_contents('../data/stats/browser/'.$file);
			}
		}
	}
}
natcasesort($browser_files);
foreach($browser_files as $data) {
	$data = explode("\n", $data);
	$browser_count = $browser_count + $data[1];
}
foreach($browser_files as $data) {
	$data = explode("\n", $data);
	$percent = ( $data[1] / $browser_count ) * 100;
	$percent = round($percent, 1);
	if ($percent >= 5 OR $percent == 4) {
		echo '
		<tr style="border: 1px solid #cccccc; border-bottom: 1px solid #cccccc; height: 30px; background-image: url(\'stats.png\'); background-repeat: repeat-y;">
			<td style="text-align: left; width: 150px; padding: 0px; vertical-align: middle">
				<span style="font-size: 10pt">' . $data[0] . '</span>
			</td>
			<td style="text-align: left; width: 600px; padding: 0px; vertical-align: middle" colspan="2">
				<div style="background-color: #000000; height: 20px; width: ' . round($percent*6, 0) . 'px; color: #ffffff; font-size: 10pt">
					' . $percent . '%
				</div>
			<td>
		</tr>';
	} else {
		echo '
		<tr style="border: 1px solid #cccccc; border-bottom: 1px solid #cccccc; height: 30px; background-image: url(\'stats.png\'); background-repeat: repeat-y;">
			<td style="text-align: left; width: 150px; padding: 0px; vertical-align: middle">
				<span style="font-size: 10pt">' . $data[0] . '</span>
			</td>
			<td style="text-align: left; padding: 0px; vertical-align: middle; width: ' . round($percent*6, 0) . 'px">
				<div style="background-color: #000000; height: 20px; width: ' . round($percent*6, 0) . 'px; color: #ffffff; font-size: 10pt">&nbsp;</div>
			</td>
			<td style="text-align: left; padding: 0px; vertical-align: middle; color: #000000; font-size: 10pt">
				<div style="padding-left: 5px;">' . $percent . '%</div>
			</td>
		</tr>';
	}
}
?>
	</tbody>
</table>
<h2>Betriebssysteme</h2>
<table style="width: 750px; border-collapse: collapse">
	<tbody>
<?php
$os_files = array();
$os_count = 0;
$folder = '../data/stats/os';
$handle = opendir($folder);
while (false !== ($file = readdir($handle))) {
	if($file != "." && $file != "..") {
		if (!isset($_GET['nobots'])) {
			$os_files[] = file_get_contents('../data/stats/os/'.$file);
		} else {
			if (substr($file, 0, 3) != 'bot') {
				$os_files[] = file_get_contents('../data/stats/os/'.$file);
			}
		}
	}
}
natcasesort($os_files);
foreach($os_files as $data) {
	$data = explode("\n", $data);
	$os_count = $os_count + $data[1];
}
foreach($os_files as $data) {
	$data = explode("\n", $data);
	$percent = ( $data[1] / $os_count ) * 100;
	$percent = round($percent, 1);
	if ($percent >= 5 OR $percent == 4) {
		echo '
		<tr style="border: 1px solid #cccccc; border-bottom: 1px solid #cccccc; height: 30px; background-image: url(\'stats.png\'); background-repeat: repeat-y;">
			<td style="text-align: left; width: 150px; padding: 0px; vertical-align: middle">
				<span style="font-size: 10pt">' . $data[0] . '</span>
			</td>
			<td style="text-align: left; width: 600px; padding: 0px; vertical-align: middle" colspan="2">
				<div style="background-color: #000000; height: 20px; width: ' . round($percent*6, 0) . 'px; color: #ffffff; font-size: 10pt">
					' . $percent . '%
				</div>
			<td>
		</tr>';
	} else {
		echo '
		<tr style="border: 1px solid #cccccc; border-bottom: 1px solid #cccccc; height: 30px; background-image: url(\'stats.png\'); background-repeat: repeat-y;">
			<td style="text-align: left; width: 150px; padding: 0px; vertical-align: middle">
				<span style="font-size: 10pt">' . $data[0] . '</span>
			</td>
			<td style="text-align: left; padding: 0px; vertical-align: middle; width: ' . round($percent*6, 0) . 'px">
				<div style="background-color: #000000; height: 20px; width: ' . round($percent*6, 0) . 'px; color: #ffffff; font-size: 10pt">&nbsp;</div>
			</td>
			<td style="text-align: left; padding: 0px; vertical-align: middle; color: #000000; font-size: 10pt">
				<div style="padding-left: 5px;">' . $percent . '%</div>
			</td>
		</tr>';
	}
}
?>
	</tbody>
</table>
<h2>Unbekannt</h2>
<p>
	Hier werden die User-Agents aufgelistet, bei denen Browser und/oder Betriebssystem nicht erkannt wurden.
</p>
<p>
<?php
if (file_exists('../data/stats/unknown.list')) {
	$unknown_content = file_get_contents('../data/stats/unknown.list');
	if ($unknown_content != '') {
		$unknown_content = htmlentities($unknown_content);
		$unknown_content = nl2br($unknown_content);
		echo $unknown_content;
	} else {
		echo 'Es sind keine unbekannten Browser und/oder Betriebssysteme vorhanden.';
	}
} else {
	echo 'Es sind keine unbekannten Browser und/oder Betriebssysteme vorhanden.';
}
?>
</p>
<h2>Aktionen</h2>
<p>
	<?php if (!isset($_GET['nobots'])) { ?>
	<a href="stats.php?nobots=yes<?php echo SID ?>">Bots ausblenden</a>
	<?php } else { ?>
	<a href="stats.php<?php echo SID ?>">Bots einblenden</a>
	<?php } ?>
</p>
<p>
	<a href="delip.php?<?php echo SID ?>">IP-Liste l&ouml;schen</a>
</p>
<p>
	<a href="addip.php?<?php echo SID ?>">Eigene IP ohne Speicherung des Browsers zur Liste hinzuf&uuml;gen</a>
</p>
<p>
	<a href="delunknown.php?<?php echo SID ?>">Liste der unerkannten Browser/OS l&ouml;schen</a>
</p>
<p>
	<a href="delstats.php?<?php echo SID ?>">Statistiken komplett l&ouml;schen</a>
</p>
<p>
	<?php
	if (isset($_GET['action'])) {
		if ($_GET['action'] == 'delip') {
			echo 'Die IP-Liste wurde gel&ouml;scht.';
		} elseif ($_GET['action'] == 'addip') {
			echo 'Ihre IP wurde zur Liste hinzugef&uuml;gt.';
		} elseif ($_GET['action'] == 'delunknown') {
			echo 'Die Liste der unbekannten Browser/OS wurde gel&ouml;scht.';
		} elseif ($_GET['action'] == 'delstats') {
			echo 'Die Statistik wurde gel&ouml;scht. <i>Die IP-Liste muss separat gel&ouml;scht werden.</i>';
		}
	}
	?>
</p>

</body>
</html>