function showmenu() {
	document.getElementById("menu").style.display = "block";
}
function hidemenu() {
	document.getElementById("menu").style.display = "none";
	menuinactive();
	barinactive("bar-menu");
}
function switchmenu() {
	if (document.getElementById("menu").style.display == "none") {
		showmenu();
		baractive("bar-menu");
	} else {
		hidemenu();
	}
}
function menuinactive() {
	document.getElementById("menu-pages").className = "menuinactive";
	document.getElementById("menu-files").className = "menuinactive";
	document.getElementById("menu-includes").className = "menuinactive";
	document.getElementById("menu-settings").className = "menuinactive";
	document.getElementById("menu-template").className = "menuinactive";
	document.getElementById("menu-space").className = "menuinactive";
	document.getElementById("menu-perms").className = "menuinactive";
	document.getElementById("menu-backup").className = "menuinactive";
	document.getElementById("menu-gbook").className = "menuinactive";
	document.getElementById("menu-stats").className = "menuinactive";
	document.getElementById("menu-recyclebin").className = "menuinactive";
}
function menuactive(foo) {
	document.getElementById(foo).className = "menuactive";
}
function baractive(foo) {
	document.getElementById(foo).className = "baractive";
}
function barinactive(foo) {
	document.getElementById(foo).className = "barinactive";
}
function bar(foo) {
	if (document.getElementById("menu").style.display == "none") {
		barinactive(foo);
	}
}
function init() {
	if (document.getElementById("iconcontainer")) {
		document.getElementById("iconcontainer").style.visibility = "visible";
	}
	document.getElementById("all").style.visibility = "visible";
	document.getElementById("javascript").style.display = "none";
	if (document.getElementById("iframe").style.display == "none") {
		document.getElementById("close").style.display = "none";
	}
	if (navigator.appName.indexOf("Explorer") != -1) {
		cwidth = document.documentElement.clientWidth;
		cheight = document.documentElement.clientHeight;
		document.getElementById("iframe").width = cwidth;
		document.getElementById("iframe").height = cheight - 24;
	} else {
		iwidth = window.innerWidth;
		iheight = window.innerHeight;
		document.getElementById("iframe").width = iwidth;
		document.getElementById("iframe").height = iheight - 24;
	}
	if (document.getElementById("date") && document.getElementById("time")) {
		setDateInvisible();
		time();
	}
}
function hideiframe() {
	document.getElementById("iframe").style.display = "none";
	document.getElementById("close").style.display = "none";
	document.getElementById("desktop").style.display = "block";
}
function showiframe() {
	document.getElementById("iframe").style.display = "block";
	document.getElementById("close").style.display = "inline";
	document.getElementById("desktop").style.display = "none";
}
function buttonactive(foo) {
	buttoninactive()
	document.getElementById(foo).className = "buttonactive";
}
function buttoninactive() {
	if (document.getElementById("split")) {
		document.getElementById("split").className = "buttoninactive";
	}
	if (document.getElementById("unsplit")) {
		document.getElementById("unsplit").className = "buttoninactive";
	}
	if (document.getElementById("logout")) {
		document.getElementById("logout").className = "buttoninactive";
	}
	document.getElementById("preview").className = "buttoninactive";
	document.getElementById("info").className = "buttoninactive";
	document.getElementById("closeb").className = "buttoninactive";
}
function time () {
	var now = new Date();
	var weekday = now.getDay(); //Wochentag ermitteln
	var dayarray = new Array("Sonntag", "Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Samstag"); //Array
	var day = now.getDate(); //Tag ermitteln
	var month = now.getMonth(); //Monat ermitteln
	var montharray = new Array("Januar", "Februar", unescape("M%E4rz"), "April", "Mai", "Juni", "Juli", "August", "September", "Oktober", "November", "Dezember"); //Array
	var year = now.getFullYear(); //Jahr ermitteln
	var hour = now.getHours(); //Stunden ermitteln
	var min = now.getMinutes(); //Minuten ermitteln
	if (min < 10) { min = "0"+min; }
	document.getElementById("time").firstChild.nodeValue = hour+":"+min;
	document.getElementById("date").firstChild.nodeValue = dayarray[weekday]+", "+day+". "+montharray[month]+" "+year;
	timeout = window.setTimeout("time()", 5000);
}
function setDateVisible() {
	document.getElementById("date").style.display = "block";
}
function setDateInvisible() {
	document.getElementById("date").style.display = "none";
}