<?php
/*
    cms -db
    Copyright (C) 2007-2008 Jan Hoffmann

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>cms -db Version</title>
<link rel="stylesheet" type="text/css" href="style.css">
</head>
<body>

<h1>&Uuml;ber <span style="font-family: FreeMono,Courier,monospace">cms </span><span style="color: #ff0000; font-family: FreeMono,Courier,monospace">-db</span></h1>
<p>
    <span style="font-family: FreeMono,Courier,monospace">cms </span><span style="color: #ff0000; font-family: FreeMono,Courier,monospace">-db</span> v0.5.1&alpha; - <a href="http://cms-db.de/">http://cms-db.de/</a><br />
    Copyright (C) 2007-2008 Jan Hoffmann<br />
	<br />
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.<br />
	<br />
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.<br />
	<br />
    You should have received a copy of the GNU General Public License
    along with this program. If not, see http://www.gnu.org/licenses/.
</p>
<p>
	<a href="gnu-gpl.php">Die GNU-GPL-Lizenz kann hier nachgelesen werden.</a>
</p>
<p>
	&nbsp;
</p>
<h2>Verwendete Objekte</h2>
<p>
	<a href="http://www.oxygen-icons.org/" target="_blank">Oxygen Icon Theme</a>
</p>
<p>
	<a href="http://tinymce.moxiecode.com/" target="_blank">TinyMCE</a>
</p>
<p>
	<a href="http://tool-man.org/examples/sorting.html" target="_blank">tool-man</a>
</p>
<p>
	<a href="http://techpatterns.com/downloads/php_browser_detection.php" target="_blank">Full Featured PHP Browser/OS detection</a>
</p>
<p>
	<a href="http://www.phpconcept.net/pclzip/index.en.php" target="_blank">PclZip</a>
</p>
<h2>&Auml;nderungen</h2>
<h3>v0.1&alpha;</h3>
<ul>
	<li>Erste Version</li>
</ul>
<h4>v0.1.1&alpha;</h4>
<ul>
	<li>Verbesserte Icons</li>
</ul>
<h4>v0.1.2&alpha;</h4>
<ul>
	<li>TinyMCE wurde abgespeckt (von 2,2MB auf 1,6MB)</li>
	<li>Einbindung von TinyMCE in Includes sowie Template</li>
</ul>
<h3>v0.2&alpha;</h3>
<ul>
	<li>komplett neue Admin-Oberfl&auml;che</li>
</ul>
<h4>v0.2.1&alpha;</h4>
<ul>
	<li>IE-Unterst&uuml;tzung des Admin-Bereiches</li>
</ul>
<h4>v0.2.2&alpha;</h4>
<ul>
	<li>verschiedene Bugfixes</li>
</ul>
<h4>v0.2.3&alpha;</h4>
<ul>
	<li>Bugfixes</li>
</ul>
<h4>v0.2.4&alpha;</h4>
<ul>
	<li>Sicherheitscode im G&auml;stebuch wird &uuml;ber SESSION &uuml;bertragen (99,9% Sicherheit)</li>
</ul>
<h4>v0.2.5&alpha;</h4>
<ul>
	<li>Bugfix des FTP-Links auf der Startseite (betrifft nur Server mit safe_mode=1)</li>
	<li>Umgehung eines PHP-Bugs der bei einigen PHP-Konfigurationen auftreten kann</li>
</ul>
<h4>v0.2.6&alpha;</h4>
<ul>
	<li>Verbesserter Sicherheitscode im G&auml;stebuch</li>
</ul>
<h4>v0.2.7&alpha;</h4>
<ul>
	<li>Bugfixes</li>
</ul>
<h4>v0.2.8&alpha;</h4>
<ul>
	<li>Funktion f&uuml;r Weiterleitungen in den Seiten</li>
	<li>verbesserte Anzeige der Dateirechte</li>
</ul>
<h4>v0.2.9&alpha;</h4>
<ul>
	<li>Das Teilen Des Arbeitsbereiches ist nun m&ouml;glich.</li>
</ul>
<h4>v0.2.10&alpha;</h4>
<ul>
	<li>Verk&uuml;rzung der URLs (&quot;sec&quot; und &quot;sub&quot; fallen weg)</li>
	<li>Men&uuml;s sowie die Sitemap werden als Liste ausgegeben</li>
</ul>
<h4>v0.2.11&alpha;</h4>
<ul>
	<li>Klapp-Men&uuml;</li>
</ul>
<h4>v0.2.12&alpha;</h4>
<ul>
	<li>URL-Rewriting ist nun m&ouml;glich</li>
	<li>Die URLs beinhalten nun keinen Eintrag "file=*" mehr</li>
</ul>
<h4>v0.2.13&alpha;</h4>
<ul>
	<li>Kleine &Auml;nderungen/Bugfixes in der Suchfunktion
		<ul>
			<li>Anpassung des Cache an neue URLs</li>
			<li>HTML-Entities in den Suchergebnissen</li>
		</ul>
	</li>
	<li>Bessere Statusanzeige beim Entpacken von Backups</li>
</ul>
<h4>v0.2.14&alpha;</h4>
<ul>
	<li>Bessere Icons</li>
	<li>Kleine Fehlerbehebungen</li>
</ul>
<h4>v0.2.15&alpha;</h4>
<ul>
	<li>&Auml;nderungen an der TinyMCE-Konfiguration (XHTML 1.1-Doctype)</li>
	<li>Anpassung des Besucherz&auml;hlers an die neue URLs</li>
	<li>Keine &uuml;berfl&uuml;ssigen Cookies mehr in den erstellten Seiten</li>
</ul>
<h4>v0.2.16&alpha;</h4>
<ul>
	<li>Verbesserte Adminoberfl&auml;che</li>
	<li>Behebung eines Bugs, der Weiterleitungen verhinderte</li>
</ul>
<h4>v0.2.17&alpha;</h4>
<ul>
	<li>&Auml;nderung der Hintergrundfarbe und der Textfarbe des Desktops des Adminbereiches ist nun m&ouml;glich</li>
	<li>Uhr im Adminbereich</li>
	<li>Verbesserte Anmeldeseite</li>
</ul>
<h3>v0.3&alpha;</h3>
<ul>
	<li>Entfernung eines falschen Elements in /admin/frame.php, das die Anzeige der JavaScript-Meldung verhinderte</li>
	<li>Kompatibilit&auml;tsmodus f&uuml;r Browser ohne JavaScript und f&uuml;r MSIE</li>
	<li>Bugfix: Beim Erstellen/Umbenennen von Seiten mit Sonderzeichen im Namen kam es bisher zu einem PHP-Fehler</li>
	<li>G&auml;stebuch ist valides XHTML (%%GUESTBOOK%% darf nicht in einem p-Element stehen!)</li>
	<li>Neues Standard-Template</li>
	<li>Browser- und Betriebssystem-Statistik</li>
	<li>Bugfix: Beim Teilen des Adminbereiches passte sich der linke Bereich aufgrund der Uhr nicht an die Fenstergr&ouml;&szlig;e an.</li>
</ul>
<h4>v0.3.1&alpha;</h4>
<ul>
	<li>Bei unbekanntem Browser und/oder Betriebssystem wird nun der User-Agent gespeichert.</li>
</ul>
<h4>v0.3.2&alpha;</h4>
<ul>
	<li>Bots von Suchmaschinen werden nun als Betriebssystem &quot;Bot&quot; aufgelistet.</li>
</ul>
<h4>v0.3.3&alpha;</h4>
<ul>
	<li>Bessere Anzeige der Statistik</li>
	<li>Bugfix: widerspr&uuml;chliche Bedingung bei OS-Erkennung entfernt</li>
	<li>Bugfix: die Elemente &lt;td&gt; in der Statistik wurden erneut ge&ouml;ffnet statt geschlossen</li>
</ul>
<h4>v0.3.4&alpha;</h4>
<ul>
	<li>Bugfix: Bots werden nun als Betriebssystem &quot;Bot&quot; statt &quot;unbekanntBot&quot; angezeigt.</li>
</ul>
<h4>v0.3.5&alpha;</h4>
<ul>
	<li>Wenn eine Seite nicht gefunden wird, wird nun &quot;404 Not Found&quot; gesendet.</li>
</ul>
<h4>v0.3.6&alpha;</h4>
<ul>
	<li>Die 404-Fehlernachricht wird nun auch angezeigt, wenn die angegebene Seite ein Ordner ist (bisher: PHP-Fehler).</li>
	<li>Die Statistik wurde erweitert, jetzt werden mehr Bots als solche erkannt.</li>
	<li>In der Statistik lassen sich nun Bots ausblenden.</li>
</ul>
<h4>v0.3.7&alpha;</h4>
<ul>
	<li>&Auml;nderung s&auml;mtlicher Copyright-Hinweise auf 2008</li>
</ul>
<h4>v0.3.8&alpha;</h4>
<ul>
	<li>Behebung eines Bugs, der verursachte, dass das &quot;FOLDINGMENU&quot; maximal 2 Ebenen anzeigte.</li>
	<li>S&auml;uberung des Codes der Datei /admin/upload.php</li>
</ul>
<h3>v0.4&alpha;</h3>
<ul>
	<li>M&ouml;glichkeit zum &Auml;ndern des angezeigten Namens von 01,Home (Startseite)</li>
	<li>Suche ohne Cache</li>
	<li>&Uuml;berarbeitung von /page/index.php</li>
	<li>Variablen f&uuml;r $beforeurl, $afterurl und $absoluteurl</li>
	<li>mehrere Benutzer m&ouml;glich</li>
	<li>neue Icon-Navigation im Adminbereich</li>
	<li>PclZip wird zum Erstellen und Entpacken von Backups verwendet.</li>
	<li>Bugfixes f&uuml;r G&auml;stebuch</li>
	<li>Neues Standarddesign der erstellten Website (altes Design von cms-db.de)</li>
	<li>Update auf TinyMCE 3</li>
	<li>Neues Symbol f&uuml;r &quot;Webseitenvorschau&quot;</li>
	<li>Neuer An- und Abmeldebildschirm</li>
	<li>Warnmeldung beim Abmelden</li>
	<li>Recycling-Center</li>
	<li>M&ouml;glichkeit zum Umbenennen von Dateien und Includes</li>
	<li>Bugfix f&uuml;r Opera</li>
</ul>
<h4>v0.4.1&alpha;</h4>
<ul>
	<li>Bugfix: Wenn beim Erstellen oder Umbennen von Includes/Dateien ein Dateiname angegeben wurde, der bereits existierte, wurde die Datei &uuml;berschrieben.</li>
</ul>
<h4>v0.4.2&alpha;</h4>
<ul>
	<li>Bugfix: Bisher wurden durch einen Fehler in der Template-Klasse alle Ersetzungen ausgef&uuml;hrt. Der Seitenaufbau sollte nun bei Seiten mit wenigen Variablen (unmerkbar) schneller gehen.</li>
</ul>
<h3>v0.5&alpha;</h4>
<ul>
	<li>
		Neue Ordnerstruktur:
		<ul>
			<li>Im Hauptverzeichnis befindet sich nun die <i>index.php</i>, die die Webseiten ausgibt, der Adminbereich ist weiterhin in <i>/admin</i> und im Ordner <i>/data</i> befindet sich alles, was Schreibrechte ben&ouml;tigt. (Updates sind nun m&ouml;glich)</li>
			<li>Das CMS muss neu installiert werden, ein Update auf Version 0.5 ist nicht m&ouml;glich.</li>
		</ul>
	</li>
	<li>Bugfix: Bei den Suchergebnissen werden Variablen jetzt nicht mehr ersetzt.</li>
	<li>Oxygen Icon Theme statt Crystal Icon Theme</li>
	<li>Komplettes Backup</li>
</ul>
<h4>v0.5.1&alpha;</h4>
<ul>
	<li>Andere Schriftart und -gr&ouml;&szlig;e im Admin-Bereich</li>
	<li>Bugfix: Einf&uuml;gen von Seiten und Dateien in Includes ist an neue Ordnerstruktur angepasst</li>
</ul>
<h2>Geplante Funktionen (f&uuml;r Version 1.0)</h2>
<ul>
	<li><span style="text-decoration:line-through">Hilfe/Dokumentation</span> - <a href="http://cms-db.de/site/07,Dokumentation/01,Home.html">Online-Dokumentation</a></li>
	<li>Einsehen und L&ouml;schen der Zugriffsz&auml;hler</li>
	<li>XHTML-Validit&auml;t des Adminbereiches</li>
	<li><span style="text-decoration:line-through">HTML-Export</span> - ab Version 0.2.12&alpha; ist URL-Rewriting m&ouml;glich</li>
	<li>Funktion zum Verwalten von mehreren Templates sowie Template-Packs</li>
</ul>
<h2>Danksagung</h2>
<p>
	Ich danke allen verwendeten PHP-Webseiten und der PHP-Dokumentation, ohne die es dieses CMS nicht geben w&uuml;rde.
</p>

</body>
</html>
