<?php
/*  cms-db  Copyright (C) 2007-2008 Jan Hoffmann
    This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
    This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details.
	
    This is an adjusted version of the Your Computer box Script from
	http://techpatterns.com/downloads/php_browser_detection.php
*/
$os = '';
$browser = '';
// change these two to match your include path/and file name you give the script
include('browser-detection.php');
$browser_info = browser_detection('full');

$browser_info[] = browser_detection('moz_version');

$unknown = 'no';

switch ($browser_info[5]) {
	case 'win':
		$os .= 'Windows ';
		break;
	case 'nt':
		$os .= 'Windows NT ';
		break;
	case 'lin':
		$os .= 'Linux, ';
		break;
	case 'mac':
		$os .= 'Mac ';
		break;
	case 'unix':
		$os .= 'Unix, ';
		break;
	default:
		if ($browser_info[5] != '') {
			$os .= $browser_info[5];
		} elseif ($browser_info[8] != 'bot') {
			$os .= 'unbekannt';
			$unknown = 'yes';
		}
}

if ( $browser_info[5] == 'nt' ) {
	if ($browser_info[6] == 5) {
		$os .= '5.0 (Windows 2000)';
	} elseif ($browser_info[6] == 5.1) {
		$os .= '5.1 (Windows XP)';
	} elseif ($browser_info[6] == 5.2) {
		$os .= '5.2 (Windows 2003)';
	} elseif ($browser_info[6] == 6.0) {
		$os .= '6.0 (Windows Vista)';
	} else {
		$os .= $browser_info[6];
	}
} elseif ( ( $browser_info[5] == 'mac' ) &&  ( $browser_info[6] >= 10 ) ) {
	$os .=  'OS X';
} elseif ( $browser_info[5] == 'lin' ) {
	$os .= ( $browser_info[6] != '' ) ? ucfirst ($browser_info[6] ) : 'unbekannte Distribution';
//} elseif ( $browser_info[6] == '' && $browser_info[5] != '') {
//	$os .=  'unbekannte Version';
} elseif ( $browser_info[8] == 'bot' && $browser_info[5] == '' ) {
	$os .=  'Bot';
	$browser .= 'Bot: ';
} else {
	$os .=  strtoupper( $browser_info[6] );
}

if ($browser_info[0] == 'moz' ) {
	$a_temp = $browser_info[count( $browser_info ) - 1];// the moz array is last item
	$browser .= ($a_temp[0] != 'mozilla') ? 'Mozilla ' . ucfirst($a_temp[0]) . ' ' : ucfirst($a_temp[0]) . ' ';
	$browser .= $a_temp[1];
} elseif  ( $browser_info[0] == 'ns' ) {
	$browser .= 'Netscape ';
	$browser .= $browser_info[1];
} elseif  ( $browser_info[0] == '' ) {
	$browser .='unbekannt';
	$unknown = 'yes';
} else {
	$browser .= ($browser_info[0] == 'ie') ? strtoupper($browser_info[7]) : ucwords($browser_info[7]);
	$browser .= ' ' . $browser_info[1];
}
?>
