<?php
/*  cms-db  Copyright (C) 2007-2008 Jan Hoffmann
    This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
    This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details.  */

if (!file_exists('./data/version.txt')) {
	echo 'Sie m&uuml;ssen das CMS zuerst einrichten!<br><br><a href="./admin/">zum Adminbereich</a>';
	die();
}

$time_start = microtime(true);

header('X-Powered-By: cms -db [http://cms-db.de/]');
header('X-Sucks: array( MSIE, Fenster );');

//$sec = $_GET['sec'];
//$sub = $_GET['sub'];
//$file = $_GET['file'];
$file_raw = urldecode(getenv("QUERY_STRING"));
if ($file_raw == "") {
  $file = "./data/pages/01,Home/01,Home";
} elseif ($_GET['special']=='gb') {
  $file = './data/pages'.urldecode($_POST['gb-page-id']); 
} else {
  $file = './data/pages'.$file_raw;
}
$splitfile = explode('/', $file_raw);
$count = count($splitfile);
//$top = $splitfile[1];
$sec = $splitfile[1];
$sub = $splitfile[$count-1];

include("./data/settings/url.inc.php");
include("./data/settings/common.inc.php");

include("functions.inc.php");

if ($_GET['special'] != "search") {
	$PageTitle = '';
	$title_temp = substr($file, 13);
	$title = explode("/", $title_temp);
	$first = 1;
	foreach($title as $text) {
		if ($first == 0) {
			$PageTitle .= ' &gt; ';
		}
		if ($text == '01,Home') {
			$text = $home;
		} else {
			$text = substr($text, 3);
			$text = str_replace("_"," ",$text);
			$text = str_replace("SLASH","/",$text);
			$text = str_replace("AND","&",$text);
		}
		$PageTitle .= htmlentities($text);
		$first = 0;
	}
} else {
	$PageTitle =  "Suchergebnisse";
}
$PageTitle = str_replace(' &gt; '.$home,"",$PageTitle);
$PageTitle = str_replace('.DEL',"",$PageTitle);
//$PageTitle = htmlentities($PageTitle,ENT_QUOTES);


if ($_GET['special'] != "search") {
	if (file_exists($file) && is_file($file)) {
		$PageContent = file_get_contents($file);
	} else {
		@header("HTTP/1.0 404 Not Found");
		$PageTitle = 'Seite nicht gefunden (Fehler 404)';
		$PageContent = '<p>Die angeforderte Seite konnte auf dem Server nicht gefunden werden. Sofern Sie den URL manuell eingegeben haben, &uuml;berpr&uuml;fen Sie bitte die Schreibweise und versuchen Sie es erneut.</p><p>M&ouml;glicherweise wurde diese Seite umbenannt oder verschoben. Dann k&ouml;nnen Sie sie in der Sitemap finden:</p>%%SITEMAP%%';
	}
} else {
	$PageContent = doSearch($_GET['q']);
}

function doInclude($match) {
	if(file_exists("./data/includes/".$match[1])) {
		ob_start();
         	include("./data/includes/".$match[1]);
		$Include = ob_get_contents();
		ob_end_clean();
         } else {
         	$Include = "<b>Die Include-Datei \"".$match[1]."\" existiert nicht!</b>";
         }
	return $Include;
}
function doRedirect($match) {
	header('Location: '.$match[1]);
}

//START TEMPLATE

include("template.class.php");

$template = new template('./data/template.tpl');

$template->readtemplate();

if ($template->hasToBeReplaced('PAGECONTENT')) {
	$template->replace("PAGECONTENT", $PageContent);
}
if ($template->hasToBeReplaced('LEFTMENU')) {
	$LeftMenu = createLeftMenu($urlbefore, $urlafter, $sec, $sub, $file);
	$template->replace("LEFTMENU", $LeftMenu);
}
if ($template->hasToBeReplaced('TOPMENU')) {
	$TopMenu = createTopMenu($urlbefore, $urlafter, $sec, $sub, $file);
	$template->replace("TOPMENU", $TopMenu);
}
if ($template->hasToBeReplaced('COMPLETEMENU')) {
	$CompleteMenu =createCompleteMenu($urlbefore, $urlafter, './data/pages', $sec, $sub);
	$template->replace("COMPLETEMENU", $CompleteMenu);
}
if ($template->hasToBeReplaced('FOLDINGMENU')) {
	$FoldingMenu = createFoldingMenu($urlbefore, $urlafter, './data/pages', $sec, $sub, $sec);
	$template->replace("FOLDINGMENU", $FoldingMenu);
}
if ($template->hasToBeReplaced('PAGETITLE')) {
	$template->replace("PAGETITLE", $PageTitle);
}
if ($template->hasToBeReplaced('PAGESEARCH')) {
	$template->replace("PAGESEARCH", '<form action="'.$urlabsolute.'/index.php" method="get">
	<div>
		<input type="hidden" name="special" value="search" />
		<input type="text" name="q" value="" size="10" maxlength="99" />
		<input type="submit" value="Suche" />
	</div>
</form>');
}
if ($template->hasToBeReplaced('LASTEDIT')) {
	$LastEdit = LastEdit();
	$template->replace("LASTEDIT", $LastEdit);
}
if ($template->hasToBeReplaced('PAGECOUNT')) {
	$PageCount = PageCount($file);
	$template->replace("PAGECOUNT", $PageCount);
}
if ($template->hasToBeReplaced('SITEMAP')) {
	$Sitemap = createSitemap($urlbefore, $urlafter, './data/pages');
	$template->replace("SITEMAP", $Sitemap);
}
$template->makeRedirects();
$template->makeIncludes();
$template->addToHead("<meta name=\"generator\" content=\"cms -db\" />");
if ($hinweis == 'on') {
	$template->addBefore("</body>",'<div id="cms-hinweis" style="text-align: center; font-size: 0.8em; font-family: Arial, Helvetica, sans serif; margin-top: 20px"><a href="http://cms-db.de/">Powered by <span style="color: #000000; font-family: FreeMono,Courier,monospace">cms </span><span style="color: #ff0000; font-family: FreeMono,Courier,monospace">-db</span></a></div>'."\n\n");
} else {
	$template->addBefore("</body>",'<!--Powered by cms -db (http://cms-db.de/)-->'."\n\n");
}
if ($template->hasToBeReplaced('URLBEFORE')) {
	$template->replace("URLBEFORE", $urlbefore);
}
if ($template->hasToBeReplaced('URLAFTER')) {
	$template->replace("URLAFTER", $urlafter);
}
if ($template->hasToBeReplaced('URLABSOLUTE')) {
	$template->replace("URLABSOLUTE", $urlabsolute);
}
if ($template->hasToBeReplaced('GUESTBOOK')) {
	ob_start();
	include("gb.php");
	$GuestBook = ob_get_contents();
	ob_end_clean();
	$template->replace("GUESTBOOK", $GuestBook);
}

$template->parse();

//ENDE TEMPLATE

//START STATISTIK
$ip = $_SERVER['REMOTE_ADDR'];
$ip_file = './data/stats/ip.list';
if (file_exists($ip_file)) { $ip_content = file_get_contents($ip_file); } else { $ip_content = ''; }
$ip_pos = strpos($ip_content, $ip);
if ($ip_pos===FALSE) {
	include('browser.php');
	$os_file = str_replace(array('<', '>', '?', '"', ':', '|', '\\', '/', '*', ',', '.', '(', ')'), '', $os);
	$os_file = str_replace(' ', '-', $os_file);
	$os_file = strtolower($os_file);
	$os_file = './data/stats/os/'.$os_file;
	if (file_exists($os_file)) { $os_content = file_get_contents($os_file); } else { $os_content = 'NONE'; }  
	$os_handle = fopen($os_file, "w+");
	if ($os_content != 'NONE') {
		$os_content = explode("\n", $os_content);
		$os_count = $os_content[1] + 1;
		fwrite($os_handle, $os_content[0]."\n".$os_count);
	} else {
		fwrite($os_handle, $os."\n1");
	}
	fclose($os_handle);
	$browser_file = str_replace(array('<', '>', '?', '"', ':', '|', '\\', '/', '*', ',', '.', '(', ')'), '', $browser);
	$browser_file = str_replace(' ', '-', $browser_file);
	$browser_file = strtolower($browser_file);
	$browser_file = './data/stats/browser/'.$browser_file;
	if (file_exists($browser_file)) { $browser_content = file_get_contents($browser_file); } else { $browser_content = 'NONE'; }
	$browser_handle = fopen($browser_file, "w+");
	if ($browser_content != 'NONE') {
		$browser_content = explode("\n", $browser_content);
		$browser_count = $browser_content[1] + 1;
		fwrite($browser_handle, $browser_content[0]."\n".$browser_count);
	} else {
		fwrite($browser_handle, $browser."\n1");
	}
	fclose($browser_handle);
	$ip_handle = fopen($ip_file, "a+");
	fwrite($ip_handle, $ip."\n");
	fclose($ip_handle);
	if ($unknown == 'yes' AND $_SERVER['HTTP_USER_AGENT'] != '') {
		$unknown_file = './data/stats/unknown.list';
		$unknown_handle = fopen($unknown_file, "a+");
		fwrite($unknown_handle, $_SERVER['HTTP_USER_AGENT']."\n");
		fclose($unknown_handle);
	}
}
//ENDE STATISTIK


$time_end = microtime(true);
$time = $time_end - $time_start;
echo "\n".'<!-- Parsed in '.$time.' seconds -->';
?>