<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!--  cms-db  Copyright (C) 2007-2008 Jan Hoffmann
      This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
      This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details. -->
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<title>%%PAGETITLE%%</title>
		<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
		<style type="text/css">
		/* <![CDATA[ */
		@media all {
			* {
				font-size: 1.0000000001em;
				font-family: Bitstream Vera Sans, Arial, Helvetica, sans-serif;
				color: #000000;
			}
			img {
				border: none;
				vertical-align: middle;
			}
			a, a:active, a:visited {
				color: #007fed;
				text-decoration: none;
			}
			a:hover {
				color: #007fed;
				text-decoration: underline;
			}
		}
		@media handheld, screen, projection, tv {
			body {
				margin: 0em;
			}
			h6, h5, h4 {
				font-size: 1.0em;
				font-weight: normal;
				border-bottom: 1px solid #aaaaaa;
			}
			h3 {
				font-size: 1.2em;
				font-weight: normal;
				border-bottom: 1px solid #aaaaaa;
			}
			h2 {
				font-size: 1.5em;
				font-weight: normal;
				border-bottom: 1px solid #aaaaaa;
			}
			h1 {
				font-size: 2.5em;
				margin: 0em;
				padding: 0.25em;
				background-color: #8f8f8f;
				background-image: url("%%URLABSOLUTE%%/data/files/standard-design_top.png");
				background-repeat: repeat-x;
				background-position: bottom;
			}
			#menu {
				padding: 0.5em;
				margin-right: 0.5em;
				margin-bottom: 0.5em;
				background-color: #efefef;
				background-image: url("%%URLABSOLUTE%%/data/files/standard-design_menu.png");
				background-repeat: repeat-x;
				background-position: top;
				border-bottom: 1px solid #aaaaaa;
			}
			#bottom {
				font-size: 0.5em;
				padding: 1em;
				border-top: 1px solid #aaaaaa;
				background-color: #8f8f8f;
				background-image: url("%%URLABSOLUTE%%/data/files/standard-design_bottom.png");
				background-repeat: repeat-x;
				background-position: top;
			}
		}
		@media screen, projection {
			#menu ul {
				padding-left: 2em;
				padding-right: 0.5em;
			}
			#menu {
				float: left;
				border-right: 1px solid #aaaaaa;
				width: 14em;
			}
			#content{
				padding-top: 0em;
				padding-left: 0.5em;
				padding-right: 0.5em;
				padding-bottom: 0.5em;
				border-top: 1px solid #aaaaaa;
				margin-left: 15em;
			}
			#content > p {
				min-width: 20em;
				max-width: 55em;
			}
			#content li {
				max-width: 55em;
			}
			#content ul, #content ol {
				list-style-position: inside;
			}
			#bottom {
				clear: both;
			}
		}
		@media print {
			#bottom, #menu {
				display: none;
			}
		}
		/* ]]> */
		</style>
		<!--#aeed68-->
		<!--[if IE]>
		<style type="text/css">
		/* <![CDATA[ */
		@media screen {
			#menu ul {
				margin: 0px;
			}
			#menu{
				padding-top: 20px;
				padding-bottom: 20px;
			}
		}
		/* ]]> */
		</style>
		<![endif]-->
		<!--[if lt IE 7]>
		<style type="text/css">
		/* <![CDATA[ */
		@media screen {
			#menu{
				width: 15em;
			}
		}
		/* ]]> */
		</style>
		<![endif]-->
	</head>
	<body>
		<h1>Meine Website</h1>
		<div id="menu">
			%%FOLDINGMENU%%
			%%PAGESEARCH%%
		</div>
		<div id="content">
			<h2>%%PAGETITLE%%</h2>
			%%PAGECONTENT%%
		</div>
		<div id="bottom">
			<a href="http://cms-db.de/">
				<img src="%%URLABSOLUTE%%/data/files/standard-design_cms-db_button.png" alt="cms -db powered" title="cms -db powered" />
			</a>
			<a href="http://validator.w3.org/check?uri=referer">
				<img src="%%URLABSOLUTE%%/data/files/standard-design_xhtml10.png" alt="XHTML 1.0" title="XHTML 1.0" />
			</a>
			<a href="http://jigsaw.w3.org/css-validator/check/referer">
				<img src="%%URLABSOLUTE%%/data/files/standard-design_css2.png" alt="CSS 2" title="CSS 2" />
			</a>
		</div>
	</body>
</html>